import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { DealerApply, DealerApplyParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询分销商申请记录表
 */
export async function pageDealerApply(params: DealerApplyParam) {
  const res = await request.get<ApiResult<PageResult<DealerApply>>>(
    MODULES_API_URL + '/shop/dealer-apply/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商申请记录表列表
 */
export async function listDealerApply(params?: DealerApplyParam) {
  const res = await request.get<ApiResult<DealerApply[]>>(
    MODULES_API_URL + '/shop/dealer-apply',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商申请记录表
 */
export async function addDealerApply(data: DealerApply) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-apply',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商申请记录表
 */
export async function updateDealerApply(data: DealerApply) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-apply',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商申请记录表
 */
export async function removeDealerApply(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-apply/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商申请记录表
 */
export async function removeBatchDealerApply(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-apply/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商申请记录表
 */
export async function getDealerApply(id: number) {
  const res = await request.get<ApiResult<DealerApply>>(
    MODULES_API_URL + '/shop/dealer-apply/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
